﻿Type=Activity
Version=3.82
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type PackageType ( _
		PackageName As String, _
		AppLabel As String, _
		Icon As Object)
		
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ULV As UltimateListView
	Dim CatULV As UltimateListView 
	Dim AnimInCatULV As AnimationPlus 
	Dim AnimOutCatULV As AnimationPlus 
	Dim tmrAnimCatTimeout As Timer 
	
	Dim PM As PackageManager 
	
	Dim HeaderIDOffset As Int = 10000
	Dim StickyPanel As Panel
	Dim lstHeaderID As List
	Dim mapHeader As Map 
	
	Dim packageList As List 
	
	Dim CatULVVisible As Boolean 
	
	Dim ReturnMode As String = "NONE"
	
	Dim bmpChecked As Bitmap   = LoadBitmap(File.DirAssets,"btn_check_on_holo_light.png")
	Dim bmpUnchecked As Bitmap = LoadBitmap(File.DirAssets,"btn_check_off_holo_light.png")
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	ULV.Initialize(0, 0, "", "ULV")
	ULV.SetStyle(ULV.STYLE_HOLO_LIGHT)
	ULV.FadingEdges(False)
	ULV.DividerHeight = 0
	ULV.AddLayout("Header", "Header_LayoutCreator", "Header_ContentFiller", 60dip, False)
	ULV.AddLayout("Item", "Item_LayoutCreator", "Item_ContentFiller", 60dip, True)
	ULV.SelectionMode = ULV.SELECTION_MULTIPLE 
	ULV.SelectWithClick = True
	
	CatULV.Initialize(0, 0, "", "CatULV")
	CatULV.SetStyle(ULV.STYLE_HOLO_LIGHT)
	'ULV.FadingEdges(False)
	CatULV.DividerHeight = 0
	CatULV.AddLayout("CatItem", "CatItem_LayoutCreator", "CatItem_ContentFiller", 32dip, True)
	
	ProgressDialogShow("Waking up dead cycles...")
	DoEvents
	DoEvents
	
	packageList.Initialize 
	For Each packagename As String In PM.GetInstalledPackages
		Dim pMap As PackageType : pMap.Initialize 
		pMap.packagename = packagename
		pMap.applabel = PM.GetApplicationLabel(packagename)
		'pMap.Icon = PM.GetApplicationIcon(packagename)
		packageList.Add(pMap)
	Next
	
	ProgressDialogHide
	
	packageList.SortType("AppLabel",True)
	
	Dim ID As Int = 0
	
	lstHeaderID.Initialize
	mapHeader.Initialize 
	Dim HeaderID As Long
	HeaderID = HeaderIDOffset
	lstHeaderID.Add(HeaderID)
	Dim firstItem As PackageType = packageList.Get(0)
	Dim LastChar As String = firstItem.applabel.CharAt(0)
	mapHeader.Put(HeaderID, LastChar)
	ULV.AddItem("Header", HeaderID)
	CatULV.AddItem("CatItem", mapHeader.Size-1)
	
	For Each pType As PackageType In packageList
		Dim applabel As String = pType.applabel 
		If applabel.CharAt(0) <> LastChar Then
			LastChar = applabel.CharAt(0)
			HeaderID = HeaderID + 1		
			lstHeaderID.Add(HeaderID)
		    mapHeader.Put(HeaderID, LastChar)
			ULV.AddItem("Header", HeaderID)
			CatULV.AddItem("CatItem", mapHeader.Size-1)
		End If
		lstHeaderID.Add(HeaderID)
		ULV.AddItem("Item", ID)
		ID = ID + 1
	Next

	Activity.AddView(ULV, 0, 0, 100%x, 100%y-48dip)

	'Creates the sticky panel over the ULV
	StickyPanel.Initialize("")
	Activity.AddView(StickyPanel, 0, 0, 100%x, 60dip)
	Header_LayoutCreator("", StickyPanel)	


	AnimInCatULV.InitializeTranslate("AnimInCatULV", 0, 0, -20%x, 0)
	AnimOutCatULV.InitializeTranslate("AnimOutCatULV", 0, 0, 20%x, 0)
	AnimInCatULV.Duration = 500
	AnimOutCatULV.Duration = 500
	
	tmrAnimCatTimeout.Initialize("tmrAnimCatTimeout", 2000)
	
	ULV.SwipeMode = ULV.SWIPE_MODE_LIST_DIR_LEFT 

	Dim btnOK, btnCancel As Button 
	btnOK.Initialize("btnOK")
	btnCancel.Initialize("btnCancel")
	Activity.AddView(btnOK, 0, 100%y-48dip, 50%x, 48dip)
	Activity.AddView(btnCancel, 50%x, 100%y-48dip, 50%x, 48dip)
	btnOK.Text = "Done"
	btnCancel.Text = "Cancel"
	
	Activity.AddView(CatULV, 100%x, 0, 20%x, 100%y)
	
	CallSubDelayed(Me, "Delay_Anim")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub GetPackageListAllow(prevList As List)
	ReturnMode = "ALLOW"
	SetPrevList(prevList)
End Sub

Sub GetPackageListBan(prevList As List)
	ReturnMode = "BAN"
	SetPrevList(prevList)
End Sub

Sub SetPrevList(prevList As List)
	Log("PrevList")
	Log(prevList)
	Dim ID As Int = 0
	For Each ptype As PackageType In packageList
		If prevList.IndexOf(ptype.PackageName) >= 0 Then
			ULV.SetSelected(ULV.GetPositionForID(ID, False),True)
		End If
		ID = ID + 1
	Next
End Sub

Sub btnOK_Click
	'Create a list of package names selected
	Dim selectedPackages As List : selectedPackages.Initialize 
	For Each ItemID In ULV.GetSelectedIDs
		Dim ptype As PackageType = packageList.Get(ItemID)
		selectedPackages.Add(ptype.PackageName)
	Next
	Log(selectedPackages)
	If ReturnMode = "ALLOW" Then
		'CallSubDelayed2(actSettingsDialog, "ReturnAllowPackageList", selectedPackages)
	Else If ReturnMode = "BAN" Then
		'CallSubDelayed2(actSettingsDialog, "ReturnBanPackageList", selectedPackages)
	End If
	Activity.Finish 
End Sub

Sub btnCancel_Click
	Activity.Finish 
End Sub

Sub ULV_SwipeBegin(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int) As Boolean
	Return True
End Sub

Sub ULV_Swiped(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int, DeltaX As Int)
	CallSubDelayed(Me, "Delay_Anim")
End Sub

Sub Header_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'The header has a label on the left and a button on the right
	LayoutPanel.Color = Colors.RGB(58,200,58)

	Dim lbl As Label
	lbl.Initialize("HeaderLabel")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 28
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	lbl.Typeface = Typeface.DEFAULT_BOLD 
	LayoutPanel.AddView(lbl, 20dip, 5dip, LayoutPanel.Width - 20dip, LayoutPanel.Height - 9dip)

End Sub

Sub Item_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Just a label
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 20
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	LayoutPanel.AddView(lbl, 20dip, 5dip, LayoutPanel.Width - 20dip, LayoutPanel.Height - 9dip)
	
	Dim chk As Panel 
	chk.Initialize("")
	LayoutPanel.AddView(chk, LayoutPanel.Width - 54dip, (LayoutPanel.Height - 38dip)/2, 38dip, 38dip)
End Sub

Sub Header_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	'Updates the text of the label
	Dim FirstNumber As Int = ItemID - HeaderIDOffset
	Dim LastNumber As Int = FirstNumber + 9
	Dim lbl As Label = LayoutPanel.GetView(0)
	lbl.Text = mapHeader.Get(ItemID)
End Sub

Sub Item_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	'Updates the text of the label
	Dim lbl As Label = LayoutPanel.GetView(0)
	lbl.Text = "ItemID = " & ItemID
	Dim PMap As PackageType = packageList.Get(ItemID)
	lbl.Text = PMap.AppLabel 
	
	Dim chk As Panel = LayoutPanel.GetView(1)
	chk.Tag = ItemID
	
	If ULV.IsSelected(Position) Then
		LayoutPanel.Color = Colors.ARGB(70, 92, 197, 104)
		chk.SetBackgroundImage(bmpChecked)
		
	Else
		LayoutPanel.Color = Colors.White 
		chk.SetBackgroundImage(bmpUnchecked)
	End If
	
End Sub

Sub ULV_Scrolled(FirstVisibleItem As Int, VisibleItemCount As Int, TotalItemCount As Int, IsAtTop As Boolean, IsAtBottom As Boolean)
	'Updates the text of the sticky panel
	Dim HeaderID As Long = lstHeaderID.Get(FirstVisibleItem)
	Header_ContentFiller(HeaderID, "", StickyPanel, FirstVisibleItem)

	'Updates the vertical position of the sticky panel
	StickyPanel.Top = 0
	If FirstVisibleItem + 1 < lstHeaderID.Size Then
		Dim NextHeaderID As Long = lstHeaderID.Get(FirstVisibleItem + 1)
		If HeaderID <> NextHeaderID Then
			'The first visible item is the last item before the next header
			StickyPanel.Top = ULV.GetVisibleTop(0)
		End If
	End If
End Sub


Sub ULV_ItemClick(ItemID As Long, Position As Int, ClickedPanel As Panel)
	Log(ItemID)
	If ItemID >= HeaderIDOffset Then 'Header
		AnimInCatULV.Start(CatULV)	
	Else
		Dim chk As Panel = ClickedPanel.GetView(1)
		If ULV.IsSelected(Position) Then
			'chk.Checked = True
		Else
			'chk.Checked = False
		End If
	End If
End Sub

Sub HeaderLabel_Click
	CallSubDelayed(Me, "Delay_Anim")
End Sub

Sub Delay_Anim
	If CatULVVisible = True Then
		Return	
	End If
	CatULVVisible = True
	AnimInCatULV.Start(CatULV)
	ULV.RefreshContent 
End Sub

Sub CatItem_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Just a label
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 16
	lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	LayoutPanel.AddView(lbl, 2dip, 2dip, LayoutPanel.Width - 2dip, LayoutPanel.Height - 4dip)
	
End Sub

Sub CatItem_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	Dim lbl As Label = LayoutPanel.GetView(0)
	lbl.Text = mapHeader.GetValueAt(ItemID)
End Sub
Sub CatULV_ScrollStateChanged(ScrollState As Int)
	tmrAnimCatTimeout.Enabled = False
	If ScrollState = ULV.SCROLLSTATE_IDLE Then
		tmrAnimCatTimeout.Enabled = True
	End If
End Sub

Sub  CatULV_ItemClick(ItemID As Long, Position As Int, ClickedPanel As Panel)
	Dim HeaderID As Long
	HeaderID = mapHeader.GetKeyAt(ItemID)
	ULV.JumpTo(ULV.GetPositionForID(HeaderID,False),True)
End Sub

Sub CatULV_Scrolled(FirstVisibleItem As Int, VisibleItemCount As Int, TotalItemCount As Int, IsAtTop As Boolean, IsAtBottom As Boolean)
End Sub
 
Sub AnimInCatULV_AnimationEnd
	AnimInCatULV.Stop(CatULV)
	CatULV.Left = CatULV.Left - 20%x
	tmrAnimCatTimeout.Enabled = True
End Sub

 Sub AnimOutCatULV_AnimationEnd
	AnimOutCatULV.Stop(CatULV)
	CatULV.Left = CatULV.Left + 20%x
	CatULVVisible = False
End Sub

 Sub tmrAnimCatTimeout_Tick
	AnimOutCatULV.Start(CatULV)
	tmrAnimCatTimeout.Enabled=False 
End Sub

